#if !defined(AFX_BUTTONFONT_H__6AECC40F_E363_498B_B876_2255874F62D8__INCLUDED_)
#define AFX_BUTTONFONT_H__6AECC40F_E363_498B_B876_2255874F62D8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct FONTSETTINGS
{
	int leftBorder;
	int topBorder;
	int rightBorder;
	int bottomBorder;

	string name;
	int height;
	int color;

	bool bold;
	bool italic;
	bool underline;

	bool shadow;
	int shadowX;
	int shadowY; 
	int shadowcolor;

	bool textoutline;
	int textoutlinecolor;

	int align;
	int vertalign;
};  

class ButtonFont  
{
public:
	ButtonFont(const string &name);
	virtual ~ButtonFont();

	void configure(const string &name);
	void apply(HDC hDC, int x, int y, int width, int height, const string &caption, int buttonType);

private:

	void subconfigure(string type, FONTSETTINGS &workSettings, FONTSETTINGS &defaultSettings);

	void createHandle(FONTSETTINGS processFont, HFONT &hfont);
	void drawOutline(HDC destHDC, RECT tmpr, int align, int vertalign, const string &caption);

	HFONT normalFont;
	HFONT activeFont;
	HFONT minimizedFont;
	HFONT flashingFont;

	FONTSETTINGS defaultfont;
	FONTSETTINGS normal;
	FONTSETTINGS active;
	FONTSETTINGS minimized;
	FONTSETTINGS flashing;
};

#endif // !defined(AFX_BUTTONFONT_H__6AECC40F_E363_498B_B876_2255874F62D8__INCLUDED_)
