/*
  RabidVWM LiteStep Module - version 1.0
	IDropTarget Interface

  Copyright (C) 2002 Joshua Seagoe
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "oleidl.h"

#define MOUSEISDRAGGING		WM_USER + 666

class DropTarget : public IDropTarget
{
private:
	bool	m_bInDragDrop;
	HWND	m_hMainWnd;
	UINT	m_uMessage;
	void	SetDropHover();
	void	ClearDropHover();
public:
	void RegisterDrop( HWND, UINT );
	
//	Required interface.
	HRESULT STDMETHODCALLTYPE QueryInterface( 
		/* [in] */ REFIID riid,
		/* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);

	ULONG STDMETHODCALLTYPE AddRef( void);

	ULONG STDMETHODCALLTYPE Release( void);

	HRESULT STDMETHODCALLTYPE DragEnter( 
		/* [unique][in] */ IDataObject *pDataObj,
		/* [in] */ DWORD grfKeyState,
		/* [in] */ POINTL pt,
		/* [out][in] */ DWORD *pdwEffect);

	HRESULT STDMETHODCALLTYPE DragOver( 
		/* [in] */ DWORD grfKeyState,
		/* [in] */ POINTL pt,
		/* [out][in] */ DWORD *pdwEffect);

	HRESULT STDMETHODCALLTYPE DragLeave( void);

	HRESULT STDMETHODCALLTYPE Drop( 
		/* [unique][in] */ IDataObject *pDataObj,
		/* [in] */ DWORD grfKeyState,
		/* [in] */ POINTL pt,
		/* [out][in] */ DWORD *pdwEffect);


//	Locally used stuff.
	HRESULT Register(HWND wnd) { cf_index=0; return RegisterDragDrop(wnd,this); }
	HRESULT static Revoke(HWND wnd) { return RevokeDragDrop(wnd); }

	static void RegisterFormats(void);

	static UINT cf_types[8];
	typedef void (DropTarget::*DropFuncPtr)(void *);
	static DropFuncPtr cf_actions[8];
	int cf_index;

	void Drop_HDROP(void *);
	void Drop_SHELLIDLIST(void *);
	void Drop_INETURL(void *);
	void Drop_SHELLURL(void *);
	void Drop_TEXT(void *);
	void Drop_UNICODETEXT(void *);
};
